"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-10-29 17:52:46
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var fs_1 = tslib_1.__importDefault(require("fs"));
var murmurhash_1 = tslib_1.__importDefault(require("murmurhash"));
var path_1 = tslib_1.__importDefault(require("path"));
var numberFormat_1 = require("./numberFormat");
var State = /** @class */ (function () {
    function State(_a) {
        var _b = _a.setDisplayName, setDisplayName = _b === void 0 ? true : _b, _c = _a.setComponentId, setComponentId = _c === void 0 ? true : _c, _d = _a.minify, minify = _d === void 0 ? true : _d, packageName = _a.packageName, context = _a.context, _e = _a.customCssTags, customCssTags = _e === void 0 ? [] : _e, _f = _a.cssTags, cssTags = _f === void 0 ? ['keyframes', 'css', 'injectGlobal', 'createGlobalStyle'] : _f;
        var cwd = process.cwd();
        this.setComponentId = setComponentId;
        this.setDisplayName = setDisplayName;
        this.minify = minify;
        this.customCssTags = customCssTags;
        this.cssTags = cssTags;
        this.cssTagsRecord = new Set(cssTags.concat(customCssTags));
        this.context = context ? path_1.default.resolve(context) : cwd;
        this.fileHash = '';
        this.filename = '';
        if (!packageName) {
            var contextFile = path_1.default.join(this.context, 'package.json');
            var cwdFile = path_1.default.join(cwd, 'package.json');
            var name_1 = fs_1.default.existsSync(contextFile)
                ? require(contextFile).name
                : fs_1.default.existsSync(cwdFile)
                    ? require(cwdFile).name
                    : void 0;
            this.packageName = name_1 || path_1.default.basename(this.context);
        }
        else {
            this.packageName = packageName;
        }
        this.files = {};
    }
    State.prototype.setFile = function (filename) {
        this.filename = filename;
        this.fileHash = '';
    };
    State.prototype.getId = function () {
        this.fileHash =
            this.fileHash ||
                numberFormat_1.itos(murmurhash_1.default(path_1.default.join(this.packageName, path_1.default.relative(this.context, this.filename))));
        if (!this.files[this.fileHash]) {
            this.files[this.fileHash] = 1;
            return this.fileHash;
        }
        else {
            return this.fileHash + '-' + this.files[this.fileHash]++;
        }
    };
    return State;
}());
exports.State = State;
//# sourceMappingURL=State.js.map