"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-10-29 13:07:13
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var typescript_1 = tslib_1.__importDefault(require("typescript"));
var minifyTemplate_1 = require("./minifyTemplate");
var should_1 = require("./should");
var State_1 = require("./State");
var withConfig_1 = require("./withConfig");
/**
 * @param program
 * @param options
 */
function createStyledComponentsTransformer(program, options) {
    var state = new State_1.State(options);
    return function (context) {
        return function (node) {
            state.setFile(node.fileName);
            var visitor = function (node) {
                // we need to iterate styled function recursively, for
                // tagged string may contains styled components, although it is
                // extremely rare case.
                // for upon reason, we need to minify first, or the node will be
                // changed.
                if (should_1.shouldMinifyNode(state, node)) {
                    node = minifyTemplate_1.minifyTemplate(node);
                }
                if (should_1.shouldWithConfig(state, node)) {
                    node = withConfig_1.withConfig(state, node);
                }
                return typescript_1.default.visitEachChild(node, visitor, context);
            };
            return typescript_1.default.visitNode(node, visitor);
        };
    };
}
exports.createStyledComponentsTransformer = createStyledComponentsTransformer;
//# sourceMappingURL=createStyledComponentsTransformer.js.map