"use strict";
/*!
 * Copyright 2019 acrazing <joking.young@gmail.com>. All rights reserved.
 * @since 2019-10-29 13:23:08
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var typescript_1 = tslib_1.__importDefault(require("typescript"));
function getDisplayName(node) {
    var parent = node.parent;
    while (parent) {
        if (typescript_1.default.isBinaryExpression(parent) && typescript_1.default.isIdentifier(parent.left)) {
            return parent.left.escapedText;
        }
        if (typescript_1.default.isVariableDeclaration(parent) && typescript_1.default.isIdentifier(parent.name)) {
            return parent.name.escapedText;
        }
        if (typescript_1.default.isPropertyAssignment(parent)) {
            if (typescript_1.default.isStringLiteral(parent.name)) {
                return parent.name.text;
            }
            if (typescript_1.default.isIdentifier(parent.name)) {
                return parent.name.escapedText;
            }
        }
        parent = parent.parent;
    }
    return void 0;
}
exports.getDisplayName = getDisplayName;
function withConfig(state, node) {
    var left = typescript_1.default.isCallExpression(node)
        ? node.expression
        : typescript_1.default.isTaggedTemplateExpression(node)
            ? node.tag
            : false;
    if (!left) {
        return node;
    }
    var properties = [];
    if (state.setComponentId) {
        properties.push(typescript_1.default.createPropertyAssignment('componentId', typescript_1.default.createStringLiteral('sc-' + state.getId())));
    }
    if (state.setDisplayName) {
        var displayName = getDisplayName(left);
        if (displayName) {
            properties.push(typescript_1.default.createPropertyAssignment('displayName', typescript_1.default.createStringLiteral(displayName)));
        }
    }
    var newLeft = typescript_1.default.createCall(typescript_1.default.createPropertyAccess(left, typescript_1.default.createIdentifier('withConfig')), void 0, [typescript_1.default.createObjectLiteral(properties, false)]);
    return typescript_1.default.isCallExpression(node)
        ? typescript_1.default.createCall(newLeft, node.typeArguments, node.arguments)
        : typescript_1.default.isTaggedTemplateExpression(node)
            ? typescript_1.default.createTaggedTemplate(newLeft, node.typeArguments, node.template)
            : node;
}
exports.withConfig = withConfig;
//# sourceMappingURL=withConfig.js.map